/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package HDBViewer;

import fr.esrf.tangoatk.widget.util.ATKGraphicsUtils;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;

/**
 *
 * @author pons
 */

class IDNameTable extends javax.swing.JDialog implements ActionListener {
    
    JTable table;
    JButton okButton;
    JButton dismissButton;
    int[] retIds;

    public IDNameTable(JDialog parent, String attName, String[] names) {

        super(parent,true);
        
        JPanel innerPanel = new JPanel();
        innerPanel.setLayout(new BorderLayout());

        String[] columns = new String[] {"Id", "Name"};
         
        //actual data for the table in a 2d array
        Object[][] data = new Object[names.length][2];
        for(int i=0;i<names.length;i++) {
            data[i][0] = Integer.toString(i);
            data[i][1] = names[i];
        }
        //create table with data
        table = new JTable(data, columns);
        table.setRowSelectionAllowed(true);
        table.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);        
         
        //add the table to the frame
        innerPanel.add(new JScrollPane(table),BorderLayout.CENTER);
        
        JPanel btnPanel = new JPanel();
        btnPanel.setLayout(new FlowLayout(FlowLayout.RIGHT));
        
        okButton = new JButton("Select");
        okButton.addActionListener(this);
        btnPanel.add(okButton);

        dismissButton = new JButton("Dismiss");
        dismissButton.addActionListener(this);
        btnPanel.add(dismissButton);
                
        innerPanel.add(btnPanel,BorderLayout.SOUTH);
        
        setContentPane(innerPanel);
         
        setTitle(attName + "[Index selection]");
        ATKGraphicsUtils.centerDialog(this);
        setVisible(true);
           
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        
        Object src = e.getSource();
        
        if( src==okButton ) {
            retIds = table.getSelectedRows();
            setVisible(false);            
        } else if (src==dismissButton) {
            retIds = null;
            setVisible(false);
        }
        
    }
    
}


public class IDSelectionDlg extends javax.swing.JDialog {

  private static IDSelectionDlg dialog = null;
  private static ArrayList<Integer> retIDs = null;
 
  private String attName;
  private String[] names;
          
  /**
   * Creates new form IDSelectionDlg
   */
  public IDSelectionDlg() {
    super((JFrame)null,true);
    initComponents();
  }
  
  private void setNames(String attName,String[] names) {
    this.names = names;
    this.attName = attName;      
    indexNameButton.setVisible(names!=null);
    setTitle(attName + " [Select Array item(s)]");
  }
  
  public static ArrayList<Integer> getIds(int maxLength,String attName,String[] idxNames) {
    
    retIDs = null;
    
    if(dialog==null)
      dialog = new IDSelectionDlg();
    dialog.setNames(attName, idxNames);
    
    if(maxLength>0)
      dialog.setInfoText("Array length: " + maxLength);
    else
      dialog.setInfoText("");

    ATKGraphicsUtils.centerDialog(dialog, 400, 200);
    dialog.setVisible(true);
    return retIDs;
    
  }
  
  private void setInfoText(String msg) {
    infoLabel.setText(msg);
  }
    
  /**
   * This method is called from within the constructor to initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is always
   * regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jScrollPane2 = new javax.swing.JScrollPane();
        infoTextArea = new javax.swing.JTextArea();
        jScrollPane1 = new javax.swing.JScrollPane();
        idText = new javax.swing.JTextArea();
        btnPanel = new javax.swing.JPanel();
        infoLabel = new javax.swing.JLabel();
        indexNameButton = new javax.swing.JButton();
        clearButton = new javax.swing.JButton();
        selectButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();

        infoTextArea.setEditable(false);
        infoTextArea.setColumns(20);
        infoTextArea.setRows(5);
        infoTextArea.setText("Enter list of ids to select. \nThe list of ids can be specified either as a comma\nseparated list of numbers or ranges (with each\nnumber in the range 0 to N-1 inclusive).\nEx: 0,1,2,44-67,82-99");
        jScrollPane2.setViewportView(infoTextArea);

        getContentPane().add(jScrollPane2, java.awt.BorderLayout.NORTH);

        idText.setColumns(20);
        idText.setRows(3);
        jScrollPane1.setViewportView(idText);

        getContentPane().add(jScrollPane1, java.awt.BorderLayout.CENTER);

        btnPanel.setLayout(new java.awt.GridBagLayout());

        infoLabel.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
        btnPanel.add(infoLabel, gridBagConstraints);

        indexNameButton.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        indexNameButton.setText("Select by names");
        indexNameButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                indexNameButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(2, 4, 2, 4);
        btnPanel.add(indexNameButton, gridBagConstraints);

        clearButton.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        clearButton.setText("Clear");
        clearButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(2, 4, 2, 4);
        btnPanel.add(clearButton, gridBagConstraints);

        selectButton.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        selectButton.setText("Select");
        selectButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                selectButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(2, 4, 2, 4);
        btnPanel.add(selectButton, gridBagConstraints);

        cancelButton.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        cancelButton.setText("Cancel");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(2, 4, 2, 4);
        btnPanel.add(cancelButton, gridBagConstraints);

        getContentPane().add(btnPanel, java.awt.BorderLayout.SOUTH);

        pack();
    }// </editor-fold>//GEN-END:initComponents

  private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
    setVisible(false);
  }//GEN-LAST:event_cancelButtonActionPerformed

  private void selectButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_selectButtonActionPerformed

    retIDs = new ArrayList<Integer>();
    String[] idDef = idText.getText().split(",");
    
    try {
      
      for(int i=0;i<idDef.length;i++) {
        int mIdx = idDef[i].indexOf('-');
        if(mIdx!=-1) {
          
          // Range x-y
          String sR = idDef[i].substring(0,mIdx);
          String eR = idDef[i].substring(mIdx+1,idDef[i].length());
          int s = Integer.parseInt(sR.trim());
          int e = Integer.parseInt(eR.trim());
          if( s>e )
            throw new Exception("Invalid range definition " + idDef[i]);
          
          for(int j=s;j<=e;j++) {
            if(retIDs.contains(j))
              throw new Exception("Invalid id list. Overlap detected");
            retIDs.add(j);
          }
          
        } else {
          
          // Simple value
          int j = Integer.parseInt(idDef[i].trim());
          if(retIDs.contains(j))
              throw new Exception("Invalid id list. Overlap detected");
            retIDs.add(j);
          
        }
      
      }

      setVisible(false);
    
    } catch (NumberFormatException e) {
      Utils.showError("Invalid number " + e.getMessage());
    } catch (Exception e) {
      Utils.showError(e.getMessage());
    }

  }//GEN-LAST:event_selectButtonActionPerformed

  private void clearButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearButtonActionPerformed
    retIDs = new ArrayList<Integer>();
    setVisible(false);
  }//GEN-LAST:event_clearButtonActionPerformed

    private void indexNameButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_indexNameButtonActionPerformed

      IDNameTable dlg = new IDNameTable(this,attName,names);
      StringBuffer idx = new StringBuffer();
      for(int i=0;i<dlg.retIds.length;i++) {
          idx.append(Integer.toString(dlg.retIds[i]));
          if(i<dlg.retIds.length-1) idx.append(",");
      }
      idText.setText(idx.toString());
        
    }//GEN-LAST:event_indexNameButtonActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel btnPanel;
    private javax.swing.JButton cancelButton;
    private javax.swing.JButton clearButton;
    private javax.swing.JTextArea idText;
    private javax.swing.JButton indexNameButton;
    private javax.swing.JLabel infoLabel;
    private javax.swing.JTextArea infoTextArea;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JButton selectButton;
    // End of variables declaration//GEN-END:variables
}
